<?php
 // Include the class:

require_once("../include/constants.php");
require_once("../include/db.class.php"); 
     
 class app
{
     
     //This functions returns a data set with all apps
     function showAllApps($pageNum=NULL, $limit=NULL)
     {
        
        // Open the database (construct the object):
        $db = new DB();
        
        if(!is_null($pageNum) && !is_null($limit))
        {
           $queryResult= $db->query("SELECT A.*, C.organizationName FROM 
                                    Application A LEFT OUTER JOIN AppOrganizationIntersection B ON A.appID=B.appID
                                    LEFT OUTER JOIN Organization C ON B.organizationID=C.organizationID  
                                    ORDER BY C.organizationName ASC,A.appName ASC LIMIT ".(($pageNum-1)*$limit).", $limit");  
        }
        else
        {
            $queryResult= $db->query("SELECT A.*, C.organizationName FROM 
                                    Application A LEFT OUTER JOIN AppOrganizationIntersection B ON A.appID=B.appID
                                    LEFT OUTER JOIN Organization C ON B.organizationID=C.organizationID  
                                    ORDER BY C.organizationName ASC,A.appName ASC");
        }
        return $queryResult;
     
     }

     //This function returns a data row for the given application
     function queryApp($appID)
     {
     
        $db = new DB();
        $queryResult= $db->query("SELECT A.*, C.organizationID,C.organizationName FROM 
                                    Application A LEFT OUTER JOIN AppOrganizationIntersection B ON A.appID=B.appID
                                    LEFT OUTER JOIN Organization C ON B.organizationID=C.organizationID  
                                    WHERE A.appID='$appID'");
        $result=$db->fetchNextObject($queryResult); 
        return $result;
     
     
     }
     //This function returns applications that belong to a given organization
     function queryOrganizationApps($organizationID)
     {
     
        $db = new DB();
        $queryResult= $db->query("SELECT A.*, B.appName FROM AppOrganizationIntersection A, Application B WHERE A.appID=B.appID and A.organizationID='$organizationID' ORDER BY B.appName");
        return $queryResult;
     
     
     }

      //This function adds an opplication to the database
     function addApp($appName,$appDescription,$appComment,$organizationID=NULL)
     {
         $appName = mysql_real_escape_string($appName);
         $appDescription = mysql_real_escape_string($appDescription); 
         $appComment = mysql_real_escape_string($appComment); 
         $appCode = md5(microtime()); //generate a random md5 code
         
         $db = new DB();
           
         $sql1="INSERT INTO Application (appName,appDescription,appComment,appCode)
                VALUES ('$appName','$appDescription','$appComment','$appCode')";
          
         $queryResult1= $db->execute($sql1);
         
         if(!is_null($organizationID) && $queryResult1)
         { 
            $appID=$db->lastInsertedId();
            $sql2="INSERT INTO AppOrganizationIntersection VALUES ('$organizationID','$appID')";
          
            $db->execute($sql2);
         }
         return $queryResult1;   

     }
     //This function updates app info in the database
     function updateApp($appID,$appName,$appDescription,$appComment)
     {
            $sql=sprintf("UPDATE Application SET appName='%s',appDescription='%s',appComment='%s' WHERE appID='$appID'",
                get_magic_quotes_gpc() ? $appName : addslashes($appName),
                get_magic_quotes_gpc() ?$appDescription : addslashes($appDescription),
                get_magic_quotes_gpc() ? $appComment : addslashes($appComment));
                
            $db = new DB();
                
            $queryResult= $db->execute($sql);
             
            return $queryResult;
         
     }
     //------------------------------------------------------------------------------------------
       //This function deletes an app from the database
       //return true if successfull, return message if failed 
     function deleteApp($appID)
     {
     
        $db = new DB();

         $db->execute("DELETE FROM AppOrganizationIntersection WHERE appID='$appID'");    
         $db->execute("DELETE FROM AdminAppIntersection WHERE appID='$appID'");
         $db->execute("DELETE FROM AppSubLocation WHERE appID='$appID'"); 
        $queryResult= $db->execute("DELETE FROM Application WHERE appID='$appID'"); 
        return $queryResult;
     
     }
     //This function checks to see if an application with this name exists in the system.
     //if an application with this name exists, return true; else false;
     function appDuplicateCheck($appName,$organizationID)
     {
         $db = new DB(); 
        if(!get_magic_quotes_gpc()){
            $appName = addslashes($appName);
        }
        $q = "SELECT A.appID FROM Application A, AppOrganizationIntersection B WHERE A.appID=B.appID and B.organizationID='$organizationID' and A.appName='$appName'";
        $result = $db->query($q);
        return (mysql_numrows($result) > 0);
     }
         
      //This functions returns a data set with all organizations
     function showAllOrganizations()
     {
        
        // Open the database (construct the object):
        $db = new DB();
      
            $queryResult= $db->query("SELECT * FROM Organization ORDER BY organizationName ASC");

        return $queryResult;
     
     }

   function displayPageNav($totalRows,$limit,$pageNum,$pageAddr)
    {

        if (($totalRows%$limit)<>0) {
            $pmax=floor($totalRows/$limit)+1;  // Divide to total result by the number of query you want
        // to display per page($limit) and create a Max page
        } else {
            $pmax=floor($totalRows/$limit);
        }
        if($pmax==1)  //if there is only 1 page, no need to display page number
            return;
            
        echo "<div class='navpage'>"; 

        // We need to create a Previous page, so we need $pageNum to be bigger than 1, otherwise at the first page we would get a 0.
        //For the previous to show up we need at least to be at the second page.
        if($pageNum > 1) {
            $prevp="<a href='".$pageAddr."?pageNum=".($pageNum-1)."' title='Previous Page'>Previous Page</a>&nbsp;&nbsp;"; 
            echo $prevp;
        } else {echo "";}   

        // Here We want create a page from the results we got by dividing the total by the the limit. So let say you got
        //45 results and you want 5 results per page; these simple lines will create you 8 pages.
        $pid=1;
        while ($pid<=$pmax) {
            $paging= "<a href='".$pageAddr."?pageNum=$pid' title='Page $pid of $pmax'>$pid</a>&nbsp;&nbsp;";
        //So here, let say we are at the 3rd page and we want the 3 to be blank so the user can know where is he now.
        //This will act as Current Page! We need to replace the url by a text
            if($pid==$pageNum)
                echo "<span>$pageNum</span>&nbsp;&nbsp;";
            else 
                echo $paging; 
            $pid++;  // create pages until reach the result
        } 
        //We want to create a next page and a last page, $pageNum have to be less than $pmax.
        if($pageNum < $pmax) {
            $nextp="<a href='".$pageAddr."?pageNum=".($pageNum+1)."' title='Next Page'>Next Page</a>&nbsp;&nbsp;"; 
            echo $nextp;
        } else {echo "";}
        if($pageNum != $pmax) {      
            echo  "<a href='".$pageAddr."?pageNum=$pmax' title='Last Page'>Last Page</a>"; }
        
        echo "</div>";
    }
}
?>
